Index: binaries/data/mods/public/simulation/data/technologies/phase_city.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/phase_city.json	(révision 17062)
+++ binaries/data/mods/public/simulation/data/technologies/phase_city.json	(copie de travail)
@@ -14,7 +14,8 @@
 	"tooltip": "Advance to City Phase, which unlocks more structures and units. Territory radius for Civic Centers increased by another +50%",
 	"modifications": [
 		{"value": "TerritoryInfluence/Radius", "multiply": 1.50, "affects": "CivCentre"},
-		{"value": "Health/Max", "multiply": 1.2, "affects": "CitizenSoldier"}
+		{"value": "Health/Max", "multiply": 1.2, "affects": "CitizenSoldier"},
+		{"value": "Capturable/GarrisonRegenRate", "add": 1.5, "affects": "Structure"}
 	],
 	"soundComplete": "interface/alarm/alarm_phase.xml"
 }
Index: binaries/data/mods/public/simulation/data/technologies/phase_city_athen.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/phase_city_athen.json	(révision 17062)
+++ binaries/data/mods/public/simulation/data/technologies/phase_city_athen.json	(copie de travail)
@@ -15,7 +15,8 @@
 	"modifications": [
 		{"value": "ResourceGatherer/Rates/metal.ore", "multiply": 1.1, "affects": "Worker"},
 		{"value": "TerritoryInfluence/Radius", "multiply": 1.50, "affects": "CivCentre"},
-		{"value": "Health/Max", "multiply": 1.2, "affects": "CitizenSoldier"}
+		{"value": "Health/Max", "multiply": 1.2, "affects": "CitizenSoldier"},
+		{"value": "Capturable/GarrisonRegenRate", "add": 1.5, "affects": "Structure"}
 	],
 	"soundComplete": "interface/alarm/alarm_phase.xml"
 }
Index: binaries/data/mods/public/simulation/data/technologies/phase_town.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/phase_town.json	(révision 17062)
+++ binaries/data/mods/public/simulation/data/technologies/phase_town.json	(copie de travail)
@@ -13,8 +13,9 @@
 	"researchTime": 30,
 	"tooltip": "Advance to Town Phase, which unlocks more structures and units. Territory radius for Civic Centers increased by +30%",
 	"modifications": [
-		{"value": "TerritoryInfluence/Radius", "multiply": 1.30, "affects":"CivCentre"},
-		{"value": "Health/Max", "multiply": 1.2, "affects": "CitizenSoldier"}
+		{"value": "TerritoryInfluence/Radius", "multiply": 1.30, "affects": "CivCentre"},
+		{"value": "Health/Max", "multiply": 1.2, "affects": "CitizenSoldier"},
+		{"value": "Capturable/GarrisonRegenRate", "add": 2.0, "affects": "Structure"}
 	],
 	"soundComplete": "interface/alarm/alarm_phase.xml"
 }
Index: binaries/data/mods/public/simulation/data/technologies/phase_town_athen.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/phase_town_athen.json	(révision 17062)
+++ binaries/data/mods/public/simulation/data/technologies/phase_town_athen.json	(copie de travail)
@@ -15,7 +15,8 @@
 	"modifications": [
 		{"value": "ResourceGatherer/Rates/metal.ore", "multiply": 1.1, "affects": "Worker"},
 		{"value": "TerritoryInfluence/Radius", "multiply": 1.30, "affects": "CivCentre"},
-		{"value": "Health/Max", "multiply": 1.2, "affects": "CitizenSoldier"}
+		{"value": "Health/Max", "multiply": 1.2, "affects": "CitizenSoldier"},
+		{"value": "Capturable/GarrisonRegenRate", "add": 2.0, "affects": "Structure"}
 	],
 	"soundComplete": "interface/alarm/alarm_phase.xml"
 }
Index: binaries/data/mods/public/simulation/templates/template_structure.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_structure.xml	(révision 17062)
+++ binaries/data/mods/public/simulation/templates/template_structure.xml	(copie de travail)
@@ -23,7 +23,7 @@
   <Capturable>
     <CapturePoints>500</CapturePoints>
     <RegenRate>0.5</RegenRate>
-    <GarrisonRegenRate>7.5</GarrisonRegenRate>
+    <GarrisonRegenRate>4.0</GarrisonRegenRate>
   </Capturable>
   <Cost>
     <Population>0</Population>