Index: binaries/data/mods/public/simulation/components/Player.js
===================================================================
--- binaries/data/mods/public/simulation/components/Player.js	(révision 17782)
+++ binaries/data/mods/public/simulation/components/Player.js	(copie de travail)
@@ -144,7 +144,7 @@
 
 Player.prototype.GetMaxPopulation = function()
 {
-	return Math.round(ApplyValueModificationsToPlayer("Player/MaxPopulation", this.maxPop, this.entity));
+	return Math.round(ApplyValueModificationsToPlayer("Player/MaxPopulation", this.maxPop, this.entity, this.playerID));
 };
 
 Player.prototype.SetGatherRateMultiplier = function(value)
Index: binaries/data/mods/public/simulation/helpers/ValueModification.js
===================================================================
--- binaries/data/mods/public/simulation/helpers/ValueModification.js	(révision 17782)
+++ binaries/data/mods/public/simulation/helpers/ValueModification.js	(copie de travail)
@@ -1,4 +1,4 @@
-// Little helper functions to make applying technology more convenient
+// Little helper functions to make applying technology and auras more convenient
 
 function ApplyValueModificationsToEntity(tech_type, current_value, entity)
 {
@@ -13,14 +13,19 @@
 	return cmpAuraManager.ApplyModifications(tech_type, value, entity);
 }
 
-function ApplyValueModificationsToPlayer(tech_type, current_value, player_entity)
+function ApplyValueModificationsToPlayer(tech_type, current_value, playerEntity,playerID)
 {
-	let cmpTechnologyManager = Engine.QueryInterface(player_entity, IID_TechnologyManager);
-
-	if (!cmpTechnologyManager)
-		return current_value;
-
-	return cmpTechnologyManager.ApplyModifications(tech_type, current_value, player_entity);
+	let value = current_value;
+	let cmpTemplateManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_TemplateManager);
+	let entityTemplateName = cmpTemplateManager.GetCurrentTemplateName(playerEntity);
+	let entityTemplate = cmpTemplateManager.GetTemplate(entityTemplateName);
+	let cmpTechnologyManager = QueryPlayerIDInterface(playerID, IID_TechnologyManager);
+	if (cmpTechnologyManager)
+		value = cmpTechnologyManager.ApplyModificationsTemplate(tech_type, current_value, entityTemplate);
+	let cmpAuraManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_AuraManager);
+	if (!cmpAuraManager)
+		return value;
+	return cmpAuraManager.ApplyTemplateModifications(tech_type, value, playerID, entityTemplate);
 }
 
 function ApplyValueModificationsToTemplate(tech_type, current_value, playerID, template)
Index: binaries/data/mods/public/simulation/templates/special/player.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/special/player.xml	(révision 17782)
+++ binaries/data/mods/public/simulation/templates/special/player.xml	(copie de travail)
@@ -48,8 +48,13 @@
       </CivilCentre>
     </LimitRemovers>
   </EntityLimits>
+  <Identity>
+    <Civ></Civ>
+    <GenericName>Player</GenericName>
+    <Classes datatype="tokens">Player</Classes>
+  </Identity>
   <Player>
-	<SharedLosTech>unlock_shared_los</SharedLosTech>
+    <SharedLosTech>unlock_shared_los</SharedLosTech>
   </Player>
   <StatisticsTracker/>
   <TechnologyManager/>
Index: binaries/data/mods/public/simulation/templates/template_structure_wonder.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_structure_wonder.xml	(révision 17782)
+++ binaries/data/mods/public/simulation/templates/template_structure_wonder.xml	(copie de travail)
@@ -10,20 +10,31 @@
       <Crush>2</Crush>
     </Foundation>
   </Armour>
+  <Auras>
+    <Aura1>
+      <Type>global</Type>
+      <Affects>Player</Affects>
+      <Modifications>
+        <Player.MaxPopulation> <Add>50</Add> </Player.MaxPopulation>
+      </Modifications>
+      <AuraName>Glorious Expansion</AuraName>
+      <AuraDescription>+50 maximum population cap.</AuraDescription>
+    </Aura1>
+  </Auras>
   <BuildRestrictions>
     <Category>Wonder</Category>
   </BuildRestrictions>
   <Capturable>
-    <CapturePoints>1500</CapturePoints>
+    <CapturePoints>2000</CapturePoints>
     <RegenRate>5.0</RegenRate>
   </Capturable>
   <Cost>
     <BuildTime>1000</BuildTime>
     <Resources>
-      <food>0</food>
-      <wood>1000</wood>
-      <stone>1000</stone>
-      <metal>1000</metal>
+      <food>3000</food>
+      <wood>4000</wood>
+      <stone>1500</stone>
+      <metal>1500</metal>
     </Resources>
   </Cost>
   <Footprint>
@@ -30,7 +41,14 @@
     <Square width="34.0" depth="34.0"/>
     <Height>10.0</Height>
   </Footprint>
-  <GarrisonHolder disable=""/>
+  <GarrisonHolder>
+    <Max>20</Max>
+    <EjectHealth>0.1</EjectHealth>
+    <EjectClassesOnDestroy datatype="tokens">Unit</EjectClassesOnDestroy>
+    <List datatype="tokens">Support Infantry Cavalry</List>
+    <BuffHeal>1</BuffHeal>
+    <LoadingRange>1</LoadingRange>
+  </GarrisonHolder>
   <Health>
     <Max>5000</Max>
     <SpawnEntityOnDeath>rubble/rubble_stone_6x6</SpawnEntityOnDeath>
@@ -41,7 +59,7 @@
     <Classes datatype="tokens">
 	  City
 	  Wonder
-	</Classes>
+    </Classes>
     <Icon>structures/wonder.png</Icon>
     <RequiredTechnology>phase_city</RequiredTechnology>
   </Identity>
@@ -55,12 +73,6 @@
   <Obstruction>
     <Static width="30.0" depth="30.0"/>
   </Obstruction>
-  <ProductionQueue>
-    <BatchTimeModifier>0.7</BatchTimeModifier>
-    <Technologies datatype="tokens">
-      pop_wonder
-    </Technologies>
-  </ProductionQueue>
   <RallyPoint disable=""/>
   <Sound>
     <SoundGroups>