Index: binaries/data/mods/public/simulation/components/Player.js
===================================================================
--- binaries/data/mods/public/simulation/components/Player.js	(révision 17771)
+++ binaries/data/mods/public/simulation/components/Player.js	(copie de travail)
@@ -142,11 +142,11 @@ Player.prototype.SetMaxPopulation = func
 	this.maxPop = max;
 };
 
 Player.prototype.GetMaxPopulation = function()
 {
-	return Math.round(ApplyValueModificationsToPlayer("Player/MaxPopulation", this.maxPop, this.entity));
+	return Math.round(ApplyValueModificationsToPlayer("Player/MaxPopulation", this.maxPop, this.entity, this.playerID));
 };
 
 Player.prototype.SetGatherRateMultiplier = function(value)
 {
 	this.gatherRateMultiplier = value;
Index: binaries/data/mods/public/simulation/data/technologies/pop_wonder.json
===================================================================
--- binaries/data/mods/public/simulation/data/technologies/pop_wonder.json	(révision 17771)
+++ binaries/data/mods/public/simulation/data/technologies/pop_wonder.json	(copie de travail)
@@ -1,21 +0,0 @@
-{
-	"genericName": "Glorious Expansion",
-	"specificName": {
-		"mace": "Peristyle",
-		"spart": "Peristyle",
-		"athen": "Peristyle",
-		"sele": "Peristyle",
-		"ptol": "Peristyle",
-		"rome": "Peristyle",
-		"pers": "Paradise"
-	},
-	"description": "The wonder attracts many more people to your civilization.",
-	"cost": {"food": 3000, "wood": 3000, "stone": 500, "metal": 500},
-	"requirements": {"tech": "phase_city"},
-	"requirementsTooltip": "Unlocked in City Phase.",
-	"icon": "special_treasure.png",
-	"researchTime": 40,
-	"tooltip": "+50 maximum population cap.",
-	"modifications": [{"value": "Player/MaxPopulation", "add": 50}],
-	"soundComplete": "interface/alarm/alarm_upgradearmory.xml"
-}
Index: binaries/data/mods/public/simulation/helpers/ValueModification.js
===================================================================
--- binaries/data/mods/public/simulation/helpers/ValueModification.js	(révision 17771)
+++ binaries/data/mods/public/simulation/helpers/ValueModification.js	(copie de travail)
@@ -1,6 +1,6 @@
-// Little helper functions to make applying technology more convenient
+// Little helper functions to make applying technology and auras more convenient
 
 function ApplyValueModificationsToEntity(tech_type, current_value, entity)
 {
 	let value = current_value;
 	let cmpTechnologyManager = QueryOwnerInterface(entity, IID_TechnologyManager);
@@ -11,18 +11,23 @@ function ApplyValueModificationsToEntity
 	if (!cmpAuraManager)
 		return value;
 	return cmpAuraManager.ApplyModifications(tech_type, value, entity);
 }
 
-function ApplyValueModificationsToPlayer(tech_type, current_value, player_entity)
+function ApplyValueModificationsToPlayer(tech_type, current_value, playerEntity,playerID)
 {
-	let cmpTechnologyManager = Engine.QueryInterface(player_entity, IID_TechnologyManager);
-
-	if (!cmpTechnologyManager)
-		return current_value;
-
-	return cmpTechnologyManager.ApplyModifications(tech_type, current_value, player_entity);
+	let value = current_value;
+	let cmpTemplateManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_TemplateManager);
+	let entityTemplateName = cmpTemplateManager.GetCurrentTemplateName(playerEntity);
+	let entityTemplate = cmpTemplateManager.GetTemplate(entityTemplateName);
+	let cmpTechnologyManager = QueryPlayerIDInterface(playerID, IID_TechnologyManager);
+	if (cmpTechnologyManager)
+		value = cmpTechnologyManager.ApplyModificationsTemplate(tech_type, current_value, entityTemplate);
+	let cmpAuraManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_AuraManager);
+	if (!cmpAuraManager)
+		return value;
+	return cmpAuraManager.ApplyTemplateModifications(tech_type, value, playerID, entityTemplate);
 }
 
 function ApplyValueModificationsToTemplate(tech_type, current_value, playerID, template)
 {
 	let value = current_value;
Index: binaries/data/mods/public/simulation/templates/special/player.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/special/player.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/special/player.xml	(copie de travail)
@@ -46,11 +46,16 @@
       <CivilCentre>
         <RequiredTechs datatype="tokens">phase_town</RequiredTechs>
       </CivilCentre>
     </LimitRemovers>
   </EntityLimits>
+  <Identity>
+    <Civ></Civ>
+    <GenericName>Player</GenericName>
+    <Classes datatype="tokens">Player</Classes>
+  </Identity>
   <Player>
-	<SharedLosTech>unlock_shared_los</SharedLosTech>
+    <SharedLosTech>unlock_shared_los</SharedLosTech>
   </Player>
   <StatisticsTracker/>
   <TechnologyManager/>
 </Entity>
Index: binaries/data/mods/public/simulation/templates/template_structure_wonder.xml
===================================================================
--- binaries/data/mods/public/simulation/templates/template_structure_wonder.xml	(révision 17771)
+++ binaries/data/mods/public/simulation/templates/template_structure_wonder.xml	(copie de travail)
@@ -8,24 +8,35 @@
       <Hack>2</Hack>
       <Pierce>10</Pierce>
       <Crush>2</Crush>
     </Foundation>
   </Armour>
+  <Auras>
+    <Aura1>
+      <Type>global</Type>
+      <Affects>Player</Affects>
+      <Modifications>
+        <Player.MaxPopulation> <Add>50</Add> </Player.MaxPopulation>
+      </Modifications>
+      <AuraName>Glorious Expansion</AuraName>
+      <AuraDescription>+50 maximum population cap.</AuraDescription>
+    </Aura1>
+  </Auras>
   <BuildRestrictions>
     <Category>Wonder</Category>
   </BuildRestrictions>
   <Capturable>
-    <CapturePoints>1500</CapturePoints>
+    <CapturePoints>2000</CapturePoints>
     <RegenRate>5.0</RegenRate>
   </Capturable>
   <Cost>
     <BuildTime>1000</BuildTime>
     <Resources>
-      <food>0</food>
-      <wood>1000</wood>
-      <stone>1000</stone>
-      <metal>1000</metal>
+      <food>3000</food>
+      <wood>4000</wood>
+      <stone>1500</stone>
+      <metal>1500</metal>
     </Resources>
   </Cost>
   <Footprint>
     <Square width="34.0" depth="34.0"/>
     <Height>10.0</Height>
@@ -39,11 +50,11 @@
     <GenericName>Wonder</GenericName>
     <Tooltip>Bring glory to your civilization and add large tracts of land to your empire.</Tooltip>
     <Classes datatype="tokens">
 	  City
 	  Wonder
-	</Classes>
+    </Classes>
     <Icon>structures/wonder.png</Icon>
     <RequiredTechnology>phase_city</RequiredTechnology>
   </Identity>
   <Loot>
     <xp>200</xp>
@@ -53,16 +64,10 @@
     <metal>100</metal>
   </Loot>
   <Obstruction>
     <Static width="30.0" depth="30.0"/>
   </Obstruction>
-  <ProductionQueue>
-    <BatchTimeModifier>0.7</BatchTimeModifier>
-    <Technologies datatype="tokens">
-      pop_wonder
-    </Technologies>
-  </ProductionQueue>
   <RallyPoint disable=""/>
   <Sound>
     <SoundGroups>
       <select>interface/select/building/sel_wonder.xml</select>
       <constructed>interface/complete/building/complete_wonder.xml</constructed>